#include <stdlib.h>
#include <time.h>
#include <handy.h>

void draw(int lid, int w, int h, int flag)
{
    int n;
    for (n = 0; n < 16; n++) {
        double x = (double)(random() % w);
        double y = (double)(random() % h);
        double r = (double)(random() % 30) + 20.0;
        double a = (random() % 31415) / 10000.0;
        if (flag) {
            HgWSetFillColor(lid, HgRGBA(n/15.0, 0.5, 1.0, 0.5));
            HgWRectFill(lid, x, y, r, 70.0 - r, a, 1);
        }else {
            HgWSetFillColor(lid, HgRGBA(0.8, 0.8, n/15.0, 0.5));
            HgWOvalFill(lid, x, y, r, 70.0 - r, a, 1);
        }
    }
}

int main(void)
{
    srandom(time(NULL));
    int wid = HgWOpen(200, 200, 400, 300);
    int layer1 = HgWAddLayer(wid);
    int layer2 = HgWAddLayer(wid);
    for ( ; ; ) {
        int ans = 0;
        HgLPDFRecord(layer1);
        HgLPDFRecord(layer2);
        draw(layer1, 400, 300, 0);
        draw(layer2, 400, 300, 1);
        ans = HgAlert("保存しますか？", "保存", "再描画", NULL);
        if (ans == 0) {
            HgLPDFSave(layer1, "pdf-1.pdf");
            HgWPDFSave(wid, "pdf-all.pdf");
            break;
        }
        HgWClear(wid);
    }
    HgCloseAll();
    return 0;
}
