#include <stdio.h>
#include <math.h>
#include <handy.h>

#define Width  800.0
#define Height 250.0
#define Scale  50.0
#define Step   0.1

double func(double x) {
    return sin(2.0 * x) + cos(x) / 2.0;
}

int main(void)
{
    double x, y;
    double x1, y1, x2, y2;
    HgOpen(Width, Height);
    HgCoordinate(Width / 2, Height / 2, Scale);
    HgTransWtoA(0.0, 0.0, &x1, &y1);
    HgTransWtoA(Width, Height, &x2, &y2);
    HgLine(x1, 0.0, x2, 0.0);
    HgLine(0.0, y1, 0.0, y2);
    HgSetWidth(2.0);
    HgSetColor(HG_BLUE);

    HgMoveTo(x1, sin(x1));
    for (x = x1 + Step; x < x2; x += Step) {
        HgLineTo(x, sin(x));
    }
    HgLineTo(x, sin(x));

    HgSetColor(HG_RED);
    HgSetFont(HG_TI, 20.0);
    HgCoordinateEnable(0);
    HgText(50, 10, "y = sin(2x) + cos(x)/2");
    HgCoordinateEnable(1);
    HgMoveTo(x1, func(x1));
    for (x = x1 + Step; x < x2; x += Step) {
        HgLineTo(x, func(x));
    }
    HgLineTo(x, func(x));

    getchar();
    HgClose();
    return 0;
}
